﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Yammer.api;

namespace AppFx.Tools.Yammer.DeploymentNotification
{
    class Program
    {
        static void Main(string[] args)
        {
            if(args == null 
                || args.Length < 5)
            {
                Console.WriteLine("Please supply the correct args: AppFx.Tools.Yammer.DeploymentNotification [token] [groupid] [environment] [componentName] [version]");
                throw new ApplicationException("Please supply the correct args");
            }

            var token = args[0];
            var groupId = args[1];
            var environment = args[2];
            var componentName = args[3];
            var versionNumber = args[4];
            
            var machineName = Environment.MachineName;
            var deploymentTime = DateTime.Now.ToString();

            var messageBuilder = new StringBuilder();
            messageBuilder.AppendLine("Deployment Completed");
            messageBuilder.AppendLine();
            messageBuilder.AppendFormat("Component Name: {0}", componentName);
            messageBuilder.AppendLine();
            messageBuilder.AppendFormat("Environment Name: {0}", environment);
            messageBuilder.AppendLine();
            messageBuilder.AppendFormat("Version Number: {0}", versionNumber);
            messageBuilder.AppendLine();
            messageBuilder.AppendFormat("Machine Name: {0}", machineName);
            messageBuilder.AppendLine();
            messageBuilder.AppendFormat("Deployed at: {0}", deploymentTime);
            messageBuilder.AppendLine();

            var client = new YammerClient(token);
            client.PostMessage(messageBuilder.ToString(), Convert.ToInt64(groupId), componentName);

            Console.WriteLine("Message published to yammer");
        }
    }
}
